// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_check

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v5/models"
)

// GetTCPChecksOKCode is the HTTP code returned for type GetTCPChecksOK
const GetTCPChecksOKCode int = 200

/*
GetTCPChecksOK Successful operation

swagger:response getTcpChecksOK
*/
type GetTCPChecksOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *GetTCPChecksOKBody `json:"body,omitempty"`
}

// NewGetTCPChecksOK creates GetTCPChecksOK with default headers values
func NewGetTCPChecksOK() *GetTCPChecksOK {

	return &GetTCPChecksOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp checks o k response
func (o *GetTCPChecksOK) WithConfigurationVersion(configurationVersion string) *GetTCPChecksOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp checks o k response
func (o *GetTCPChecksOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp checks o k response
func (o *GetTCPChecksOK) WithPayload(payload *GetTCPChecksOKBody) *GetTCPChecksOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp checks o k response
func (o *GetTCPChecksOK) SetPayload(payload *GetTCPChecksOKBody) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPChecksOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetTCPChecksDefault General Error

swagger:response getTcpChecksDefault
*/
type GetTCPChecksDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPChecksDefault creates GetTCPChecksDefault with default headers values
func NewGetTCPChecksDefault(code int) *GetTCPChecksDefault {
	if code <= 0 {
		code = 500
	}

	return &GetTCPChecksDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get TCP checks default response
func (o *GetTCPChecksDefault) WithStatusCode(code int) *GetTCPChecksDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get TCP checks default response
func (o *GetTCPChecksDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get TCP checks default response
func (o *GetTCPChecksDefault) WithConfigurationVersion(configurationVersion string) *GetTCPChecksDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get TCP checks default response
func (o *GetTCPChecksDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get TCP checks default response
func (o *GetTCPChecksDefault) WithPayload(payload *models.Error) *GetTCPChecksDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get TCP checks default response
func (o *GetTCPChecksDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPChecksDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
